#include <nds.h>
#include "fw.h"
#include "../../arm7/include/ipc.h"

#include "mkdshack.h"

u8 mkds_list[] = {
	1,9,10,11,12,13,14,15,16,17,18,19,20,
	22,23,24,25,26,27,28,29,30,31,32,33,
  34,35,36,37,38,39,40};
  
u8 mkds_reverse[] = {
	0x14, 0x16, 0x1F, 0x12,
	0x1B, 0x1C, 0x21, 0x18,
	0x1E, 0x11, 0x19, 0x13,
	0x22, 0x1A, 0x20, 0x1D,
	0x0A, 0x0B, 0x0D, 0x0E,
	0x23, 0x10, 0x0C, 0x09,
	0x0F, 0x24, 0x25, 0x26,
	0x27, 0x17, 0x28, 0x01
};

u8 mkds_list_offset[]={
	0,  32, 0,  0, 
	0,  0,  0,  0, 
	0,  24, 17, 18, 
	23, 19, 20, 25,
	22, 10, 4,  12,
	1,  0,  2,  30,
	8,  11, 14, 5,
	6,  16, 9,  3,
	15, 7,  13, 21,
	26, 27, 28, 29,
	31};
	
unsigned char offline_patch[88] =
{
    0x2C, 0x00, 0x9F, 0xE5, 0x2C, 0x10, 0x9F, 0xE5, 
    0x00, 0x10, 0x80, 0xE5, 0x28, 0x00, 0x9F, 0xE5, 
    0x2C, 0x10, 0x8F, 0xE2, 0x14, 0x20, 0xA0, 0xE3, 
    0x01, 0x30, 0xD1, 0xE4, 0x04, 0x30, 0x80, 0xE4, 
    0x01, 0x20, 0x52, 0xE2, 0xFB, 0xFF, 0xFF, 0xCA, 
    0x10, 0x40, 0x9F, 0xE5, 0x04, 0xF0, 0xA0, 0xE1, 
    0xFE, 0xFF, 0xFF, 0xEA, 0x50, 0xFE, 0x3F, 0x02, 
    0x00, 0xB6, 0x0E, 0x00, 0x4C, 0x3A, 0x15, 0x02, 
    0x00, 0x30, 0x00, 0x02, 
    
    //Offline Courses
    0x0C, 0x0F, 0x11, 0x13,
    0x17, 0x18, 0x1A, 0x20,
    0x21, 0x23, 0x25, 0x26,
    
    //Online Courses
    0x14, 0x1D, 0x1E, 0x1F,
    0x1C, 0x24, 0x28, 0x01,
    
} ;
	

char *text_mkdshack[]={
	"== MKDS COURSE LIST ==",
	"LOAD MKDS",
	"RETURN TO MAIN",
	
	//Mushroom Cup
	"Figure-8 Circuit         ",
	"Yoshi Falls              ",
	"Cheep Cheep Beach        ",
	"Luigi's Mansion          ",//4
	
	//Flower Cup
	"Desert Hills             ",
	"Delfino Square           ",
	"Waluigi Pinball ***      ",
	"Shroom Ridge ***         ",//8
	
	//Star Cup
	"DK Pass                  ",
	"Tick-Tock Clock ***      ",
	"Mario Circuit            ",
	"Airship Fortress ***     ",//12
	
	//Special Cup
	"Wario Stadium            ",
	"Peach Gardens ***        ",
	"Bowser Castle ***        ",
	"Rainbow Road             ",//16
	
	//Shell Cup
	"SNES Mario Circuit       ",
	"N64 Moo Moo Farm         ",
	"GBA Peach Circuit        ",
	"GCN Luigi Circuit        ",//20
	
	//Banana Cup
	"SNES Donut Plains 1 ***  ",
	"N64 Frappe Snowland      ",
	"GBA Bowser Castle 2 ***  ",
	"GCN Baby Park            ",//24
	
	//Leaf Cup
	"SNES Koopa Beach 2 ***   ",
	"N64 Choco Mountain       ",
	"GBA Luigi Circuit ***    ",
	"GCN Mushroom Bridge ***  ",//28
	
	//Lightning Cup
	"SNES Choco Island 2      ",
	"N64 Banshee Boardwalk ***",
	"GBA Sky Garden           ",
	"GCN Yoshi Circuit        "};//32
	
void mkds_option(char * txt[], int line, int select) {
	char *s;
	int i;
	u16 *p=(u16*)(SCREEN_BASE_BLOCK_SUB(0)+line*64);
	
	if(line<3)
		s=txt[line];
	else
	{
		i=offline_patch[68+(line-3)];
		s=txt[mkds_list_offset[i]+2];
	}
	*p++ = select? (0x1000|'*') : ' ';
	while(*s) *p++=(*s++)|(select?0x1000:0);
}

void menu_mkds_hack() {
	u32 i,selected,j;
	u32 k;
	
	//Check to see if MKDS is actually in the DS card slot.  If not, then we should
	//Not be messing with the game card inserted.
	if(Read_PMemory(0x2000918) != 0x00)
		return;
	if(Read_PMemory(0x2000919) != 0x30)
		return;
	for(i=0;i<88;i++)
		if(Read_PMemory(0x2000C20+i)!=0x00)
			return;
	

	selected=1;
	while(1) {
		swiWaitForVBlank();
		for(i=0;i<23;i++)
			mkds_option(text_mkdshack,i,i==selected);

		k=keyhit();
		if(IPC_XKEYS & 0x80)	//lid closed
			arm9sleep();
		if(k&KEY_UP)
			selected--;
		if(k&KEY_DOWN)
			selected++;
		//if(k&KEY_L)
		//	lcdSwap();
		if(k&KEY_START)
			return;
		selected%=23;
		if(selected==0 && (k&KEY_UP)) selected=23-1;
		if(selected==0 && !(k&KEY_UP)) selected=1;
		if((k&KEY_LEFT) || (k&KEY_RIGHT) || (k&KEY_A) || (k&KEY_B)) {
			if(selected > 2)
			{
					i=offline_patch[68+(selected-3)];
					for(j=0;j<32;j++)
					{
						if(mkds_reverse[j]==i)
							break;
					}
					i=j;
					if(k&KEY_LEFT) i=(i+31)%32;
					if(k&KEY_RIGHT) i=(i+1)%32;
					if(k&KEY_B) i=(i-16)%32;
					if(k&KEY_A) i=(i+16)%32;
					offline_patch[68+(selected-3)] = mkds_reverse[i];
			}
						
		}
		if(k&KEY_SELECT) {
			if(selected==1)
			{
					Write_PMemory(0x02000918,0x20);
					Write_PMemory(0x02000919,0x0C);
					for(i=0;i<88;i++)
						Write_PMemory(0x02000C20+i,offline_patch[i]);
					IPC_ARM9=IPC_NDS;
					while((IPC_ARM7!=IPC_NDS_GO)&&(IPC_ARM7!=IPC_NDS_STOP))
						swiDelay(0);
					if(IPC_ARM7==IPC_NDS_GO)
					{
						hardware_init();
						//while(IPC_ARM7!=IPC_NDS_GO)
						//	swiDelay(0);
						(*(call0*)0x27ffe24)();
					}
			}
			if(selected==2)
				break;
		}
	}
}